///home/berryj/link/bin/genMethods "-g" "-t" "int" "-h" "SortedList" "-r" "List<int>" "-I" "LINK/basic/SortedList.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SortedList.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef int _int;
typedef SortedList<int > _SortedList_int_;
static SortedList<int > s__SortedList_int_;

#define _SortedList_int_DATA(x) ((SortedList<int >*) (EXTDATA(x)))
#define _SortedList_int_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<int > >::type))
#define _SortedList_int_ISNT_DATA(x) (!_SortedList_int_IS_DATA(x))

#define _SortedList_int_CXX_DATA(x) (*(SortedList<int >*) (EXTDATA(VAL(x))))
#define _SortedList_int_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<int > >::type))
#define _SortedList_int_CXX_ISNT_DATA(x) (!_SortedList_int_CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedList_int_()
{
	Wrapper<_SortedList_int_>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedList_int_>::name, 
			Wrapper<List<int> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_int>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_int>::markTypedList,
			(void (*)(SCM x))ListWrapper<_int>::freeTypedList);
	Tcl_InitHashTable(&Register<_SortedList_int_>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedList_int_Methods(void);

PRIMITIVE STk_init_methods__SortedList_int_()
{
	genExtra_SortedList_int_Methods();
	return UNDEFINED;
}
